*
*        ASSEMBLER ROUTINES FOR ALGOL 68 IN ALGOL W.
*
         GBLC  &OSYSTEM
         GBLB  &MTS
&OSYSTEM SETC  'OS'
&MTS     SETB  0
         AIF   ('&OSYSTEM' NE 'MTS').NOTMTS
&MTS     SETB  1
.NOTMTS  ANOP
         TITLE 'DCBD'
         AIF   (&MTS).MTS10
         DCBD  DSORG=PS
.MTS10   ANOP
         TITLE 'INOPEN'
*        INTEGER PROCEDURE INOPEN(
*           STRING(8) VALUE DDNAME;
*           STRING(2) VALUE OPTIONS);
*
*        OPEN A FILE WITH DDNAME 'DDNAME'. NO CHECK IS MADE
*        WHETHER THIS FILE IS ALREADY OPEN.
*        YIELD A POINTER (DISGUISED AS AN INTEGER) INDICATING THIS
*        FILE.
*
INOPEN   CSECT
         SAVE  (14,12),,INOPEN
         LR    11,15
         USING INOPEN,11
         L     2,0(1)
         LA    3,=C'S '
         TM    0(1),X'80'
         BNZ   ONEPAR
         L     3,4(1)
ONEPAR   DS    0H
         AIF  (&MTS).MTS1
         LA    0,LOCSIZE
         GETMAIN  R,LV=(0)
         AGO   .ALL1
.MTS1    ANOP
         LA    0,1
         LA    1,LOCSIZE
         CALL  GETSPACE
.ALL1    ANOP
         ST    1,8(13)
         ST    13,4(1)
         LR    13,1
         USING LOCAREA,13
*
         AIF   (&MTS).MTS2
*
*        LOOK AT OPTIONS
         MVI   INOPTS,0
         CLI   0(3),C'S'
         BNE   NOTS
         OI    INOPTS,NUMBERED
NOTS     DS    0H
         MVC   INOPTION(1),INOPTS
*              INOPTION WILL BE CHANGED IF OPTIONS DON'T WORK,
*              AND RECOMPUTED AT EACH CONCATENATION BOUNDARY.
*        PREPARE A PROPERLY MODIFIED COPY OF SDCB.
         LA    7,DCB
         USING IHADCB,7
         MVC   DCB(DCBSIZE),SDCB
         MVC   DCBDDNAM(8),0(2)
         MVI   NOREAD,X'FF'
*
         MVC   OPENL(OPENSIZE),SOPENL
         OPEN  (DCB,),MF=(E,OPENL)
         AGO   .ALL2
.MTS2    ANOP
         MVC   DDNAME(8),0(2)
         LA    6,TRYOPEN
         BALR  5,6
.ALL2    ANOP
         LA    0,0
         ST    0,RADDR
         ST    0,RLEN
         ST    0,LINENO
         LR    0,13
         L     13,4(13)
         ST    0,20(13)
         RETURN (14,12),T,RC=0
         DROP  11,13
         TITLE 'READLINE'
*        PROCEDURE READLINE(
*           INTEGER VALUE FILE;
*           STRING(1) RESULT CC;
*           STRING(256) RESULT AREA;
*           INTEGER RESULT LENGTH;
*           LOGICAL RESULT FIRST, LAST;
*           STRING(8) RESULT LINENO;
*           LOGICAL RESULT EOF;
*           INTEGER VALUE MAXLEN);
*
*        READ A LINE FROM THE FILE INDICATED BY 'FILE',
*              'CC' BECOMES ITS CARRIAGE CONTROL CHARACTER, IF ANY,
*                 AND OTHERWISE BLANK.
*        'AREA' BECOMES THE INPUT LINE, WITHOUT LENGTH INDICATION
*              OR CARRIAGE CONTROL, PADDED WITH BLANKS.
*        'LENGTH' BECOMES THE LENGTH OF THE INPUT LINE.
*        'LINENO' BECOMES SOME LINE NUMBER.
*        'EOF' BECOMES 'TRUE' IF END OF FILE WAS REACHED AND
*              CONSEQUENTLY NO LINE COULD BE REACHED.
*        'EOF' BECOMES 'FALSE' IF END OF FILE WAS NOT REACHED.
*
*        IF THE INPUT LINE IS LONGER THAN MAXLEN CHARACTERS,
*        IT IS BROKEN INTO PIECES.
*        'FIRST' BECOMES 'TRUE' IF WE ARE AT THE FIRST PIECE
*           OF A LINE
*        'LAST' BECOMES 'TRUE' IF WE ARE AT THE LAST PIECE
*           OF A LINE;
*
*        TEMPORARY RESTRICTION: PIECES OF LENGTH > 256 ARE NEVER
*                PRODUCED.
*
         ENTRY READLINE
READLINE SAVE  (14,12),,READLINE
         LR    11,15
         USING READLINE,11
         LR    2,1        Save parameter list
         L     1,0(1)
         L     1,0(1)
         ST    13,4(1)
         ST    1,8(13)
         LR    13,1
         USING LOCAREA,13
         LA    3,256
         TM    28(2),X'80'
         BNZ   NOMAXLEN
         L     3,32(2)
         L     3,0(3)
NOMAXLEN C     3,=F'256'
         BNH   MAXLENOK
         LA    3,256
MAXLENOK ST    3,MAXLEN
         L     3,8(2)
         USING AREA,3
         LA    4,AREA
         L     5,MAXLEN
         LA    6,0
         LA    7,0
         ICM   7,8,=C' '
         MVCL  4,6
*
         MVI   LAST,X'01'
*
*        BRANCH TO LENCHECK IF THERE IS A RECORD ALREADY.
         LM    8,9,RADDR
         LTR   9,9
         MVI   FIRST,X'00'
         BH    LENCHECK
         MVI   FIRST,X'01'
*
         AIF   (&MTS).MTS3
TRYREAD  MVI   REREAD,0
         LA    7,DCB
         USING DCB,7
         USING IHADCB,7
         GET   DCB                     LOCATE MODE
         CLI   REREAD,0
         BNZ   TRYREAD                 DID WE PASS OVER A CONCATENATION
*
         LR    8,1
         LH    9,DCBLRECL
         AGO   .ALL3
.MTS3    ANOP
TRYREAD  LA    1,INPARS
         CALL  READ
         LTR   0,0
         BE    NOSWITCH
         LA    6,TRYOPEN
         BALR  5,6
         B     TRYREAD
NOSWITCH LTR   15,15
         BNE    EODAD
YES      L     8,AREG
         LH    9,HLENGTH
.ALL3    ANOP
*        8  HAS RECORD ADDRESS
*        9 HAS RECORD LENGTH
         AIF   (&MTS).ALL4
         L     10,LINENO
         A     10,=F'1'
         ST    10,LINENO
*
*        VARIABLE LENGTH RECORD ?
FCHECK   TM    DCBRECFM,F              IS IT F OR U?
         BNZ   ACHECK
*
         TM    2(8),X'02'
         BZ    LACHECK
         MVI   FIRST,X'00'
LACHECK  TM    2(8),X'01'
         BZ    JUNKSKIP
         MVI   LAST,X'00'
JUNKSKIP LA    8,4(8)                  SKIP SEGMENT CONTROL WORD
         S     9,=F'4'
.ALL4    ANOP
*
*        CARRIAGE CONTROL ?
ACHECK   MVI   CC,C' '
         AIF   (&MTS).MTS5
         TM    FIRST,X'01'
         BZ    LENCHECK
         TM    DCBRECFM,A
         BZ    NUM
         AGO   .ALL5
.MTS5    ANOP
         TM    CCEXISTS,X'01'
         BZ    LENCHECK
.ALL5    ANOP
         LTR   9,9
         BNH   EMPTY
         MVC   CC(1),0(8)
         LA    8,1(8)
         BCTR  9,0
         AIF   (&MTS).ALL11
NUM      TM    INOPTION,NUMBERED
         BZ    OWNNUM
         C     9,=F'8'
         BL    OWNNUM
         TM    DCBRECFM,F
         BNZ   FNUM
         TM    FIRST,X'01'    START OF V RECORD?
         BZ    LENCHECK  USE OLD LINE NUMBER IF NOT.
         MVC   LINENUM(8),0(8)
         BAL   6,CHECKNUM
         A     8,=F'8'
         S     9,=F'8'
         B     LENCHECK
FNUM     LA    4,0(8,9)
         S     4,=F'8'
         MVC   LINENUM(8),0(4)
         BAL   6,CHECKNUM
         S     9,=F'8'
         B     LENCHECK
*     CHECK LINE NUMBER FOR VALIDITY.
*         USE RETURN ADDRESS IN REG 6 IF OK
*         OTHERWISE JUMP TO OWNNUM
CHECKNUM TM    INOPTION,ANYNUM
         BNZR  6
         CLI   LINENUM,C'0'
         BL    OWNNUM
         CLI   LINENUM+1,C'0'
         BL    OWNNUM
         CLI   LINENUM+2,C'0'
         BL    OWNNUM
         CLI   LINENUM+3,C'0'
         BL    OWNNUM
         CLI   LINENUM+4,C'0'
         BL    OWNNUM
         CLI   LINENUM+5,C'0'
         BL    OWNNUM
         CLI   LINENUM+6,C'0'
         BL    OWNNUM
         CLI   LINENUM+7,C'0'
        BL    OWNNUM
         BR    6
.ALL11   ANOP
OWNNUM   CVD   10,LINEDEC
         UNPK  LINENUM(8),LINEDEC(8)
         OI    LINENUM+7,X'F0'
         NI    INOPTION,255-NUMBERED
OLDNUM   DS    0H
*
*        CHECK LINE LENGTH
LENCHECK LA    10,0
         ST    10,RLEN
*
         LTR   9,9
         BNH   EMPTY
*            LINE IS NOT EMPTY
         C     9,MAXLEN
         BNH   MOVE
*            LINE IS TOO LONG
         S     9,MAXLEN
         ST    9,RLEN
         LR    9,8
         A     9,MAXLEN
         ST    9,RADDR
         L     9,MAXLEN
         MVI   LAST,X'00'
*
*        MOVE THE INPUT LINE
MOVE     ST    9,LENGTH
         BCTR  9,0
         EX    9,MVC
         B     FINISH
MVC      MVC   AREA(0),0(8)
*
*        EMPTY LINE
EMPTY    LA    9,0
         ST    9,LENGTH
*
FINISH   MVI   EOF,X'00'
         L     4,4(2)
         MVC   0(1,4),CC
         L     4,12(2)
         MVC   0(4,4),LENGTH
         L     4,16(2)
         MVC   0(1,4),FIRST
         L     4,20(2)
         MVC   0(1,4),LAST
         L     4,24(2)
         MVC   0(8,4),LINENUM
         L     4,28(2)
         MVC   0(1,4),EOF
         L     13,4(13)
         RETURN (14,12),T,RC=0
*
EODAD    MVI   EOF,X'01'
         L     4,28(2)
         MVI   0(4),X'01'
         L     13,4(13)
         RETURN (14,12),T,RC=4
*
         DROP  3,11,13
         LTORG
         AIF   (&MTS).MTS6
         TITLE 'STANDARD DCB'
SDCB     DCB   DSORG=PS,               DCB TO BE COPIED                X
               EODAD=EODAD,                                            X
               EXLST=EXLST,                                            X
               MACRF=GL,                                               X
               BFTEK=A
DCBSIZE  EQU   *-SDCB
SOPENL   OPEN  (,(INPUT)),MF=L
OPENSIZE EQU   *-SOPENL
         LTORG
EXLST    DC    X'85',AL3(EX)
         USING DCB,7
         USING IHADCB,1
         USING EX,15
EX       CLC   DCBBLKSI,=H'0'
         BNE   *+10
         MVC   DCBBLKSI,DCBLRECL
         CLC   DCBBLKSI,=H'0'
         BNE   *+10
         MVC   DCBBLKSI,=H'133'
         CLC   DCBLRECL,=H'0'
         BNE   *+10
         MVC   DCBLRECL,DCBBLKSI
         TM    NOREAD,X'FF'
         BNZ   EX1
         MVI   REREAD,1
         MVC   INOPTION(1),INOPTS
         BR    14
EX1      MVI   NOREAD,0
         OI    DCBOFLGS,X'08'
         BR    14
         DROP  1,7,15
         AGO   .ALL6
.MTS6    ANOP
         TITLE 'TRYOPEN'
         USING TRYOPEN,6
         USING LOCAREA,13
TRYOPEN  LM    0,1,DDNAME
         CALL  GDINFO
         LTR   15,15
         BZ    OPENED
         MVC   MESSAGE,=C'CANNOT FIND XXXXXXXX.'
         MVC   MESSAGE+12(8),DDNAME
         MVC   SERCOMP(SERCOML),SERCOMS
         SERCOM MESSAGE,MF=(E,SERCOMP)
         CALL MTS
         B     TRYOPEN
SERCOMS  SERCOM MF=L
SERCOML  EQU   *-SERCOMS
*
OPENED   LR    4,1
         USING GOTINFO,4
         MVC   FDUB(4),GOTFDUB
*    CARRIAGE CONTROL
         MVI   CCEXISTS,X'00'
         TM    GOTIOMOD+3,X'80'
         BZ    ECC
         MVI   CCEXISTS,X'01'
ECC      DS    0H
*    INPUT BUFFER
         LH    1,GOTINLEN
         LA    0,1
         CALL  GETSPACE
         ST    1,AREG
*    FREE GDINFO AREA
         LA    0,0
         LR    1,4
         CALL FREESPAC
*
         LA    1,HLENGTH
         ST    1,ALEN
         LA    1,MOD
         ST    1,AMOD
         LA    1,LINENO
         ST    1,ALNUM
         LA    1,DDNAME
         ST    1,AUNIT
         BR 5
         DS    0F
MOD      DC    X'80000000'
.ALL6    ANOP
         LTORG
         TITLE 'CLOSE'
*  PROCEDURE INCLOSE(
*     INTEGER VALUE FILE);
*     FORTRAN "INCLOSE";
         ENTRY INCLOSE
INCLOSE  SAVE  (14,12),,INCLOSE
         LR    11,15
         USING INCLOSE,11
         L     1,0(1)
         L     1,0(1)
         ST    13,4(1)
         ST    1,8(13)
         LR    13,1
         USING LOCAREA,13
         AIF   (&MTS).MTS9
        MVC   CLOSEL(OPENSIZE),SCLOSEL
         CLOSE (DCB,LEAVE),MF=(E,CLOSEL)
         LA    0,LOCSIZE
         LR    1,13
         L     13,4(13)
         FREEMAIN R,LV=(0),A=(1)
         AGO   .ALL9
.MTS9    ANOP
         L     0,FDUB
         CALL  FREEFD
         LA    0,0
         LR    1,13
         L     13,4(13)
         CALL  FREESPAC
.ALL9    ANOP
         RETURN (14,12),T,RC=0
SCLOSEL  CLOSE (,),MF=L
         TITLE 'DATA'
LOCAREA  DSECT
SAVE     DS    18F
*        REST OF PREVIOUS RECORD
RADDR    DS    F
RLEN     DS    F
*
*      PARAMETERS
CC       DS    C
LENGTH   DS    F
LINENUM  DS    D
EOF      DS    C
FIRST    DS    C
LAST     DS    C
MAXLEN   DS    F
*
LINENO   DS    F
NUMBERED EQU   X'01'
ANYNUM   EQU   X'02'
LINEDEC  DS    D
         AIF   (&MTS).MTS7
OPENL    DS    0D
CLOSEL   EQU   OPENL
         DS    (OPENSIZE)C
DCB      DS    0D
         DS    (DCBSIZE)C
REREAD   DS    C
NOREAD   DS    C
INOPTION DS    C
INOPTS   DS    C
DDNAME   EQU   DCB+(DCBDDNAM-IHADCB)
         AGO   .ALL7
.MTS7    ANOP
CCEXISTS DS    C
FDUB     DS    F
DDNAME   DS    8C
INPARS   DS    0F
AREG     DS    F
ALEN     DS    F
AMOD     DS    F
ALNUM    DS    F
AUNIT    DS    F
*
HLENGTH  DS    H
MESSAGE  DS    CL21
SERCOMP  SERCOM MF=L
.ALL7    ANOP
LOCSIZE  EQU   *-LOCAREA
AREA     DSECT
         DS    256C
         AIF   (&MTS).MTS8
*
*        RECFM BITS
F        EQU   X'80'
V        EQU   X'40'
U        EQU   F+V
B        EQU   X'10'
S        EQU   X'08'
A        EQU   X'04'
         AGO   .ALL8
.MTS8    ANOP
GOTINFO  DSECT
GOTFDUB  DS    F    FDUB POINTER
GOTTYPE  DS    CL4
GOTINLEN DS    H    MAXIMUM INPUT LENGTH
GOTOTLEN DS    H    MAXIMUM OUTPUT LENGTH
GOTFBDTP DS    F    FDUB TYPE
GOTIOMOD DS    F    IO MODIFIERS
GOTSTART DS    F    STARTING LINE NUMBER
GOTLAST  DS    F    LAST LINE NUMBER USED IN I/O
GOTEND   DS    F    ENDING LINE NUMBER
GOTINCR  DS    F    LINE NUMBER INCREMENT
GOTFDPTR DS    F    POINTER TO FDNAME (LENGTH + STRING)
GOTERROR DS    F    POINTER TO LAST ERROR MESSAGE (LENGTH + STRING)
.ALL8    ANOP
         END
